

----
--
----
----missione creata da PVI-Eagle---------------------------------
--

  
------------------------------------------------------------------------------------------------------------------------------------  
-----------------------
--- WAREHOUSE class.

-- Display mission time every 30 seconds.
SCHEDULER:New(nil, UTILS.DisplayMissionTime, {5}, 30, 30)
BASE:E(" --- START WAREHOUSE MISSION ---")

BASE:TraceClass("WAREHOUSE")
BASE:TraceOnOff(true)

-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-- Define Warehouses.
local warehouse={}



--Base rifornimenti BLU    KUTAISI
warehouse.Base_Rifornimenti_BLU  = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Rifornimenti_BLU"),  "Base_Rifornimenti_BLU")  --Functional.Warehouse#WAREHOUSE
--warehouse.Base_Rifornimenti_BLU:SetSpawnZone(ZONE:New("Base_Rifornimenti_BLU Spawn Zone"))
warehouse.Base_Rifornimenti_BLU:Start()
warehouse.Base_Rifornimenti_BLU:SetReportOff()
warehouse.Base_Rifornimenti_BLU:AddAsset("T72_GEORGIA", 180)
warehouse.Base_Rifornimenti_BLU:AddAsset("BTR80_GEORGIA", 50)
warehouse.Base_Rifornimenti_BLU:AddAsset("BMP2_GEORGIA", 50)
warehouse.Base_Rifornimenti_BLU:AddAsset("2S3_GEORGIA", 100)
warehouse.Base_Rifornimenti_BLU:AddAsset("DANA_GEORGIA", 100)
warehouse.Base_Rifornimenti_BLU:AddAsset("MORTAR_GEORGIA", 30)
warehouse.Base_Rifornimenti_BLU:AddAsset("BUK_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("OSA_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("STINGER_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("MI24_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("MI8_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("INFANTRY_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("BM27_GEORGIA", 10)
warehouse.Base_Rifornimenti_BLU:AddAsset("SU25_GEORGIA", 10)
--warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Rifornimenti_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_TRANSPORTHELO, 1, nil, nil, nil, nil)
warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Rifornimenti_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, nil) 
warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Rifornimenti_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 2, nil, nil, nil, nil)
  -- Pause the warehouse after 60 seconds
warehouse.Base_Rifornimenti_BLU:__Pause(60)


--Base_Interna_BLU   SENAKI
warehouse.Base_Interna_BLU   = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Interna_BLU"),   "Base_Interna_BLU")   --Functional.Warehouse#WAREHOUSE
--warehouse.Base_Interna_BLU:SetSpawnZone(ZONE:New("Base_Interna_BLU Spawn Zone"))
warehouse.Base_Interna_BLU:Start()
warehouse.Base_Interna_BLU:SetReportOff()
warehouse.Base_Interna_BLU:AddAsset("T72_GEORGIA", 20)
warehouse.Base_Interna_BLU:AddAsset("BTR80_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("BMP2_GEORGIA", 5)
warehouse.Base_Interna_BLU:AddAsset("2S3_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("DANA_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("MORTAR_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("BUK_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("OSA_GEORGIA", 4)
warehouse.Base_Interna_BLU:AddAsset("STINGER_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("MI24_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("MI8_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("INFANTRY_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("BM27_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddAsset("SU25_GEORGIA", 10)
warehouse.Base_Interna_BLU:AddRequest(warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, nil) 
warehouse.Base_Interna_BLU:AddRequest(warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_ARTILLERY, 1, nil, nil, nil, nil) 
  -- Pause the warehouse after 60 seconds
warehouse.Base_Interna_BLU:__Pause(60)

--Base avanzata BLU   GORI
warehouse.Base_Avanzata_BLU   = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Avanzata_BLU"),   "Base_Avanzata_BLU")   --Functional.Warehouse#WAREHOUSE
--warehouse.Base_Avanzata_BLU:SetSpawnZone(ZONE:New("Base_Avanzata_BLU Spawn Zone"))
warehouse.Base_Avanzata_BLU:Start()
warehouse.Base_Avanzata_BLU:SetReportOff()
warehouse.Base_Avanzata_BLU:AddAsset("T72_GEORGIA", 20)
warehouse.Base_Avanzata_BLU:AddAsset("BTR80_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("BMP2_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("2S3_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("DANA_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("MORTAR_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("BUK_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("OSA_GEORGIA", 4)
warehouse.Base_Avanzata_BLU:AddAsset("STINGER_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("MI24_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("MI8_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("INFANTRY_GEORGIA", 10)
warehouse.Base_Avanzata_BLU:AddAsset("BM27_GEORGIA", 10)


-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

--Base avanzata ROSSI   TSKHINVALI
warehouse.Base_Avanzata_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Avanzata_ROSSI"), "Base_Avanzata_ROSSI") --Functional.Warehouse#WAREHOUSE
--warehouse.Base_Avanzata_ROSSI:SetSpawnZone(ZONE:New("Base_Avanzata_ROSSI Spawn Zone"))
warehouse.Base_Avanzata_ROSSI:Start()
warehouse.Base_Avanzata_ROSSI:SetReportOff()
warehouse.Base_Avanzata_ROSSI:AddAsset("T72_RUSSIA", 14)
warehouse.Base_Avanzata_ROSSI:AddAsset("BTR80_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("BMP2_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("BMP1_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("MLTB_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("SU25_RUSSIA", 10)
warehouse.Base_Avanzata_ROSSI:AddAsset("MI24_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("2S3_RUSSIA", 16)
warehouse.Base_Avanzata_ROSSI:AddAsset("GRAD_RUSSIA", 9)
warehouse.Base_Avanzata_ROSSI:AddAsset("INFANTRY_RUSSIA", 40)
warehouse.Base_Avanzata_ROSSI:AddAsset("MI8_RUSSIA", 20)
warehouse.Base_Avanzata_ROSSI:AddAsset("TOR_RUSSIA", 20)

--Base Rifornimenti ROSSI  ROKI TUNNEL
warehouse.Base_Rifornimenti_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Rifornimenti_ROSSI"),   "Base_Rifornimenti_ROSSI")   --Functional.Warehouse#WAREHOUSE
warehouse.Base_Rifornimenti_ROSSI:SetSpawnZone(ZONE_POLYGON:New("Base_Rifornimenti_ROSSI Spawn Zone", GROUP:FindByName("Base_Rifornimenti_ROSSI Spawn Zone")))
--warehouse.Base_Rifornimenti_ROSSI:SetSpawnZone(ZONE:New("Base_Rifornimenti_ROSSI Spawn Zone"))
warehouse.Base_Rifornimenti_ROSSI:Start()
warehouse.Base_Rifornimenti_ROSSI:SetReportOff()
warehouse.Base_Rifornimenti_ROSSI:AddAsset("T72_RUSSIA", 14)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("BTR80_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("BMP2_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("BMP1_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("MLTB_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("SU25_RUSSIA", 10)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("MI24_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("2S3_RUSSIA", 16)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("GRAD_RUSSIA", 9)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("INFANTRY_RUSSIA", 10)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("MI8_RUSSIA", 20)
warehouse.Base_Rifornimenti_ROSSI:AddAsset("TOR_RUSSIA", 20)

--warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, nil) 
warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, nil)  
warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 3, nil, nil, nil, nil) 

--Base_Interna_ROSSI   DJAVA
warehouse.Base_Interna_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_Interna_ROSSI"),   "Base_iNTERNA_ROSSI")   --Functional.Warehouse#WAREHOUSE
warehouse.Base_Interna_ROSSI:SetSpawnZone(ZONE:New("Base_Interna_ROSSI Spawn Zone"))
warehouse.Base_Interna_ROSSI:Start()
warehouse.Base_Interna_ROSSI:SetReportOff()
warehouse.Base_Interna_ROSSI:AddAsset("T72_RUSSIA", 14)
warehouse.Base_Interna_ROSSI:AddAsset("BTR80_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddAsset("BMP2_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddAsset("BMP1_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddAsset("MLTB_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddAsset("SU25_RUSSIA", 10)
warehouse.Base_Interna_ROSSI:AddAsset("MI24_RUSSIA", 20, WAREHOUSE.Attribute.AIR_ATTACKHELO)
warehouse.Base_Interna_ROSSI:AddAsset("2S3_RUSSIA", 16)
warehouse.Base_Interna_ROSSI:AddAsset("GRAD_RUSSIA", 9)
warehouse.Base_Interna_ROSSI:AddAsset("INFANTRY_RUSSIA", 50)
warehouse.Base_Interna_ROSSI:AddAsset("MI8_RUSSIA", 20, WAREHOUSE.Attribute.AIR_TRANSPORTHELO)
warehouse.Base_Interna_ROSSI:AddAsset("TOR_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddAsset("SHILKA_RUSSIA", 20)
warehouse.Base_Interna_ROSSI:AddRequest(warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, nil) 
warehouse.Base_Interna_ROSSI:AddRequest(warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, nil) 

--Warehouse Base_BATTLEZONE_ROSSI A OCHAMCHIRA
warehouse.Base_BATTLEZONE_ROSSI = WAREHOUSE:New(STATIC:FindByName("Warehouse Base_BATTLEZONE_ROSSI"),   "Base_BATTLEZONE_ROSSI")   --Functional.Warehouse#WAREHOUSE
warehouse.Base_BATTLEZONE_ROSSI:Start()
warehouse.Base_BATTLEZONE_ROSSI:SetReportOff()
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("T72_RUSSIA", 14)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("BTR80_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("BMP2_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("BMP1_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("MLTB_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("SU25_RUSSIA", 10)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("MI24_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("2S3_RUSSIA", 16)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("GRAD_RUSSIA", 9)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("INFANTRY_RUSSIA", 50)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("MI8_RUSSIA", 20)
warehouse.Base_BATTLEZONE_ROSSI:AddAsset("TOR_RUSSIA", 20)


--------------------------------------------RICHIESTA DA PARTE DI Base_BATTLEZONE_ROSSI CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE2") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit2")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )


-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.Base_BATTLEZONE_ROSSI:__AddRequest(time, warehouse.Base_BATTLEZONE_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 2, nil, nil, nil, "To Battle Zone")
  --warehouse.Base_BATTLEZONE_ROSSI:__AddRequest(time, warehouse.Base_BATTLEZONE_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_INFANTRY, 4, WAREHOUSE.TransportType.APC, 2, nil, "To Battle Zone") 

end


-- Take care of the spawned units.
function warehouse.Base_BATTLEZONE_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_BATTLEZONE_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())    

    end
        
  end
  
end
        
-- An asset has died ==> request resupply for it.
function warehouse.Base_BATTLEZONE_ROSSI:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem  
  
  -- Get assignment.
  local assignment= warehouse.Base_BATTLEZONE_ROSSI:GetAssignment(request)
  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
 warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_BATTLEZONE_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 

 -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_BATTLEZONE_ROSSI:AddRequest(warehouse.Base_BATTLEZONE_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "To Battle Zone")
end


--------------------------------------------RICHIESTA DA PARTE DI Base_Avanzata_ROSSI CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE") 
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Avanzata_ROSSI:__AddRequest(time, warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_INFANTRY, 1, nil, nil, nil, "To Battle Zone") 
end

 
-- Take care of the spawned units.
function warehouse.Base_Avanzata_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Avanzata_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())    
    end
        
  end
  
end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Avanzata_ROSSI:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment=warehouse.Base_Avanzata_ROSSI:GetAssignment(request)

  -- Request resupply for dead asset from Base_Rifornimenti_ROSSI.
  --warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, WAREHOUSE.Quantity.ALL, WAREHOUSE.TransportType.AIRPLANE, nil, nil, "Resupply") 
  warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply")
  
  -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_Avanzata_ROSSI:AddRequest(warehouse.Base_Avanzata_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "To Battle Zone")
end



--------------------------------------------RICHIESTA DA PARTE DI Base_Interna_ROSSI CHE MANDA I TANK ALLA BATTLE ZONE 2--------------------------------------
--
---- Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

  warehouse.Base_Interna_ROSSI:__AddRequest(time, warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Interna_ROSSI:__AddRequest(time, warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Interna_ROSSI:__AddRequest(time, warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_ARTILLERY, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Interna_ROSSI:__AddRequest(time, warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_TRANSPORTHELO, 1, nil, nil, nil, "BAI") 
  warehouse.Base_Interna_ROSSI:__AddRequest(time, warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.AIR_ATTACKHELO, 1, nil, nil, nil, "BAI")
end


-- Take care of the spawned units.
function warehouse.Base_Interna_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Interna_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  elseif assignment=="BAI" then
      
      -- Start uncontrolled helo.
        local group=groupset:GetFirst() --Wrapper.Group#GROUP
       group:StartUncontrolled()
       
       local BAIEngagementZone = ZONE:New( "Gori Zone" )
       
       local BAI=AI_BAI_ZONE:New(ZONE:New("Patrol Zone"), 500, 1000, 500, 600, BAIEngagementZone)
        
    
         -- Tell the program to use the object (in this case called BAIPlane) as the group to use in the BAI function
           BAI:SetControllable(group)
          
                     
           -- Start BAI
           BAI:Start()
           
           -- Engage after 1 minuto.
           BAI:__Engage(60)
          
          -- RTB after 30 min max.
           BAI:__RTB(18000)  
           
      end
  end
           

-- An asset has died ==> request resupply for it.
function warehouse.Base_Interna_ROSSI:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment=warehouse.Base_Interna_ROSSI:GetAssignment(request)

  -- Request resupply for dead asset from Base_Rifornimenti_ROSSI.
  --warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, WAREHOUSE.Quantity.ALL, WAREHOUSE.TransportType.AIRPLANE, nil, nil, "Resupply") 
  warehouse.Base_Rifornimenti_ROSSI:AddRequest(warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 
  
  -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_Interna_ROSSI:AddRequest(warehouse.Base_Interna_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, assignment)
end




---------------------------------------------------------------SE BASE AVANZTA ROSSI DISTRUTTA BASE RIFORNIMENTI ROSSI MANDA DIRETTAMENTE ALLA BATTLEZONE---------------------------
--
------ Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.


function warehouse.Base_Avanzata_ROSSI:onafterDestroyed(From, Event, To)
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_ARTILLERY, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To Battle Zone") 
  end
end

-- Take care of the spawned units.
function warehouse.Base_Rifornimenti_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Rifornimenti_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  end
  
end


---------------------------------------------------------------SE BASE INTERNA ROSSI DISTRUTTA BASE RIFORNIMENTI ROSSI MANDA DIRETTAMENTE ALLA BATTLEZONE ---------------------------
------ Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.



function warehouse.Base_Interna_ROSSI:onafterDestroyed(From, Event, To)
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_ARTILLERY, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Rifornimenti_ROSSI:__AddRequest(time, warehouse.Base_Rifornimenti_ROSSI, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_SAM, 1, nil, nil, nil, "To Battle Zone") 
  end
end

-- Take care of the spawned units.
function warehouse.Base_Rifornimenti_ROSSI:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Rifornimenti_ROSSI:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  end
  
end


------------------------------------------------------------------B  L  U------------------------------------------------------------------------------------
--
--
--
--------------------------------------------RICHIESTA DA PARTE DI Base_Avanzata_BLU CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
------ Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE3")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

  warehouse.Base_Avanzata_BLU:__AddRequest(time, warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Avanzata_BLU:__AddRequest(time, warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  --warehouse.Base_Avanzata_BLU:__AddRequest(time, warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_AAA, 1, nil, nil, nil, "To Battle Zone") 
end

 
-- Take care of the spawned units.
function warehouse.Base_Avanzata_BLU:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Avanzata_BLU:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  end
  
end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Avanzata_BLU:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment=warehouse.Base_Avanzata_BLU:GetAssignment(request)

  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
  --warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, WAREHOUSE.Quantity.ALL, WAREHOUSE.TransportType.AIRPLANE, nil, nil, "Resupply") 
  warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply")
  
  -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_Avanzata_BLU:AddRequest(warehouse.Base_Avanzata_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "To Battle Zone")
end

--------------------------------------------RICHIESTA DA PARTE DI Base_Interna_BLU CHE MANDA I TANK ALLA BATTLE ZONE--------------------------------------
------ Battle zone . This is where the action is!
local BattleZone=ZONE:New("BATTLEZONE2")
--local BATTLEZONEunit = UNIT:FindByName ("BATTLEZONEunit2")
--local BattleZone= ZONE_UNIT:New( "BattleZone", BATTLEZONEunit, 100 )
  
-- Send  groups to the battle zone. Two groups every ~60 seconds.
for i=1,2 do
  local
  time=(i-1)*60+10

  warehouse.Base_Interna_BLU:__AddRequest(time, warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_TANK, 1, nil, nil, nil, "To Battle Zone") 
  warehouse.Base_Interna_BLU:__AddRequest(time, warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_APC, 1, nil, nil, nil, "To Battle Zone")
  warehouse.Base_Interna_BLU:__AddRequest(time, warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, WAREHOUSE.Attribute.GROUND_ARTILLERY, 1, nil, nil, nil, "To Battle Zone") 
end

 
-- Take care of the spawned units.
function warehouse.Base_Interna_BLU:OnAfterSelfRequest(From,Event,To,groupset,request)
  local groupset=groupset --Core.Set#SET_GROUP
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment of this request.
  local assignment=warehouse.Base_Interna_BLU:GetAssignment(request)
  
  if assignment=="To Battle Zone" then
    
    for _,group in pairs(groupset:GetSet()) do
      local group=group --Wrapper.Group#GROUP
      
      -- Route group to Battle zone.
      local ToCoord=BattleZone:GetRandomCoordinate()
      group:RouteGroundOnRoad(ToCoord, group:GetSpeedMax())
      
    end
        
  end
  
end

-- An asset has died ==> request resupply for it.
function warehouse.Base_Interna_BLU:OnAfterAssetDead(From, Event, To, asset, request)
  local asset=asset       --Functional.Warehouse#WAREHOUSE.Assetitem
  local request=request   --Functional.Warehouse#WAREHOUSE.Pendingitem
  
  -- Get assignment.
  local assignment=warehouse.Base_Interna_BLU:GetAssignment(request)

  -- Request resupply for dead asset from Base_Rifornimenti_BLU.
  warehouse.Base_Rifornimenti_BLU:AddRequest(warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "Resupply") 
  
  -- Send asset to Battle zone either now or when they arrive.
  warehouse.Base_Interna_BLU:AddRequest(warehouse.Base_Interna_BLU, WAREHOUSE.Descriptor.ATTRIBUTE, asset.attribute, 1, nil, nil, nil, "To Battle Zone")
end


--------------------------------------------------------------------------------------------------------------------------------------------------------------------------
--
--
--


------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Avanzata_ROSSI--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Avanzata_ROSSI:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}
  

  
end

------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Rifornimenti_ROSSI--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Rifornimenti_ROSSI:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}

end

------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Rifornimenti_BLU--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Rifornimenti_BLU:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}

end

------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Avanzata_BLU--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Avanzata_BLU:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}

end


------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Interna_BLU--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Interna_BLU:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}

end


------------------------------------------------------MESSAGGIO IN CASO DISTRUZIONE WAREHOUSE Base_Interna_ROSSI--------------------------------------------------------

--- On after "Destroyed" event. Warehouse was destroyed. All services are stopped. Warehouse is going to "Stopped" state in one minute.
-- @param #WAREHOUSE self
-- @param #string From From state.
-- @param #string Event Event.
-- @param #string To To state.
function warehouse.Base_Interna_ROSSI:onafterDestroyed(From, Event, To)

  -- Message.
  local text=string.format("Warehouse %s was destroyed! Assets lost %d.", self.alias, #self.stock)
  self:_InfoMessage(text)
  
  -- Remove all table entries from waiting queue and stock.
  for k,_ in pairs(self.queue) do
    self.queue[k]=nil
  end
  for k,_ in pairs(self.stock) do
    self.stock[k]=nil
  end

  --self.queue=nil
  --self.queue={}

  --self.stock=nil
  --self.stock={}

end
